unit MAIN;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, System.Actions, scStyledForm,
  scImageCollection, scControls, scStyleManager, Vcl.FormTabsBar,
  System.ImageList, Vcl.VirtualImageList, Vcl.BaseImageCollection,
  Vcl.ImageCollection, Vcl.PlatformDefaultStyleActnCtrls, Vcl.ActnMan,
  Vcl.ActnCtrls, Vcl.ActnMenus, scFormTabsBar;

type
  TMainForm = class(TForm)
    OpenDialog: TOpenDialog;
    StatusBar: TscStatusBar;
    ActionList1: TActionList;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    FileNew1: TAction;
    FileSave1: TAction;
    FileExit1: TAction;
    FileOpen1: TAction;
    FileSaveAs1: TAction;
    HelpAbout1: TAction;
    FileClose1: TWindowClose;
    ToolBar2: TscToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton9: TToolButton;
    scStyleManager1: TscStyleManager;
    ImageCollection1: TImageCollection;
    VirtualImageList1: TVirtualImageList;
    ActionMainMenuBar1: TActionMainMenuBar;
    ActionManager1: TActionManager;
    scStyledForm1: TscStyledForm;
    ClientPanel: TscPanel;
    scFormTabsBar1: TscFormTabsBar;
    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure HelpAbout1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure ActionMDIArrangeExecute(Sender: TObject);
    procedure FileSave1Execute(Sender: TObject);
    procedure WindowTileHorizontal1Execute(Sender: TObject);
    procedure WindowTileVertical1Execute(Sender: TObject);
    procedure WindowCascade1Execute(Sender: TObject);
    procedure scFormTabsBar1AcceptForm(AForm: TForm; var AAccept: Boolean);
  private
    { Private declarations }
    Count: Integer;
    procedure DoTile(ATileMode: TTileMode);
    procedure CreateNewForm(AControl: TWinControl; AName: String = '');
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses ChildWin, about;

procedure TMainForm.CreateNewForm(AControl: TWinControl; AName: String = '');
var
  F: TSDIChild;
begin
  SendMessage(AControl.Handle, WM_SETREDRAW, 0, 0);
  Inc(Count);
  F := TSDIChild.Create(Self);
  F.ScaleForPPI(CurrentPPI);
  if AName = '' then
  begin
    F.Caption := 'NoName ' + Count.ToString;
    F.Memo1.Text := F.Caption;
  end
  else
  begin
    F.Caption := AName;
    if FileExists(AName) then F.Memo1.Lines.LoadFromFile(AName);
  end;
  F.Parent := AControl;
  F.Show;
  SendMessage(AControl.Handle, WM_SETREDRAW, 1, 0);
  RedrawWindow(AControl.Handle, nil, 0,
    RDW_ERASE or RDW_INVALIDATE or RDW_FRAME or RDW_ALLCHILDREN or RDW_UPDATENOW);
end;

procedure TMainForm.DoTile(ATileMode: TTileMode);
begin
  TileMode := ATileMode;
  Tile;
end;

procedure TMainForm.ActionMDIArrangeExecute(Sender: TObject);
begin
  if (FormStyle = fsMDIForm) and (ClientHandle <> 0) then
    SendMessage(ClientHandle, WM_MDIICONARRANGE, 0, 0);
end;

procedure TMainForm.FileNew1Execute(Sender: TObject);
begin
  CreateNewForm(ClientPanel);
end;

procedure TMainForm.FileOpen1Execute(Sender: TObject);
begin
  if OpenDialog.Execute then
    CreateNewForm(ClientPanel, OpenDialog.FileName);
end;

procedure TMainForm.FileSave1Execute(Sender: TObject);
begin
  //
end;

procedure TMainForm.HelpAbout1Execute(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TMainForm.scFormTabsBar1AcceptForm(AForm: TForm;
  var AAccept: Boolean);
begin
   AAccept := AForm is TSDIChild;
end;

procedure TMainForm.WindowCascade1Execute(Sender: TObject);
begin
  Cascade;
end;

procedure TMainForm.WindowTileHorizontal1Execute(Sender: TObject);
begin
  DoTile(tbHorizontal);
end;

procedure TMainForm.WindowTileVertical1Execute(Sender: TObject);
begin
  DoTile(tbVertical);
end;

procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

end.
