unit MAIN;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, Menus,
  StdCtrls, Dialogs, Buttons, Messages, ExtCtrls, ComCtrls, StdActns,
  ActnList, ToolWin, ImgList, System.Actions, scStyledForm,
  scImageCollection, scControls, scStyleManager,
  System.ImageList, Vcl.VirtualImageList, Vcl.BaseImageCollection,
  Vcl.ImageCollection, Vcl.PlatformDefaultStyleActnCtrls, Vcl.ActnMan,
  Vcl.ActnCtrls, Vcl.ActnMenus, scGPControls, scGPFontControls, scFormTabsBar,
  scGPImages, Vcl.Themes, scHint;

type
  TMainForm = class(TForm)
    BorderPanel: TscGPPanel;
    scGPPanel2: TscGPPanel;
    CloseButton: TscGPGlyphButton;
    MinButton: TscGPGlyphButton;
    MaxButton: TscGPGlyphButton;
    scGPPanel4: TscGPPanel;
    scGPThemedCharGlyphButton3: TscGPThemedCharGlyphButton;
    scGPThemedCharGlyphButton1: TscGPThemedCharGlyphButton;
    scGPThemedCharGlyphButton2: TscGPThemedCharGlyphButton;
    scGPThemedCharGlyphButton4: TscGPThemedCharGlyphButton;
    scGPThemedCharGlyphButton5: TscGPThemedCharGlyphButton;
    scGPThemedCharGlyphButton6: TscGPThemedCharGlyphButton;
    scGPThemedCharGlyphButton7: TscGPThemedCharGlyphButton;
    scGPPanel5: TscGPPanel;
    scGPSizeBox1: TscGPSizeBox;
    scLabel10: TscLabel;
    OpenDialog: TOpenDialog;
    ActionList1: TActionList;
    FileNew1: TAction;
    FileOpen1: TAction;
    FileClose1: TWindowClose;
    FileSave1: TAction;
    FileSaveAs1: TAction;
    FileExit1: TAction;
    EditCut1: TEditCut;
    EditCopy1: TEditCopy;
    EditPaste1: TEditPaste;
    HelpAbout1: TAction;
    scStyleManager1: TscStyleManager;
    ImageCollection1: TImageCollection;
    VirtualImageList1: TVirtualImageList;
    scStyledForm1: TscStyledForm;
    scFormTabsBar1: TscFormTabsBar;
    ClientPanel: TscPanel;
    scGPImageCollection1: TscGPImageCollection;
    PopupMenu1: TPopupMenu;
    New1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    TabsMenuButton: TscGPGlyphButton;
    PopupMenu2: TPopupMenu;
    Windows1: TMenuItem;
    N3: TMenuItem;
    Styles1: TMenuItem;
    N2: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    procedure FileNew1Execute(Sender: TObject);
    procedure FileOpen1Execute(Sender: TObject);
    procedure FileExit1Execute(Sender: TObject);
    procedure ActionMDIArrangeExecute(Sender: TObject);
    procedure FileSave1Execute(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure scFormTabsBar1AcceptForm(AForm: TForm; var AAccept: Boolean);
    procedure scFormTabsBar1FormDraggingAreaDblClick(Sender: TObject);
    procedure MaxButtonClick(Sender: TObject);
    procedure scFormTabsBar1StartFormDragging(Sender: TObject);
    procedure scFormTabsBar1StopFormDragging(Sender: TObject);
    procedure scFormTabsBar1FormDragging(Sender: TObject);
    procedure scStyledForm1DWMClientMaximize(Sender: TObject);
    procedure scStyledForm1DWMClientRestore(Sender: TObject);
    procedure scGPPanel4MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure scGPPanel4MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure scGPPanel4MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure MinButtonClick(Sender: TObject);
    procedure scStyledForm1ChangeActive(Sender: TObject);
    procedure PopupMenu2Popup(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure scFormTabsBar1Changed(Sender: TObject);
  private
    { Private declarations }
    Count: Integer;
    procedure CreateNewForm(AControl: TWinControl; AName: String = '');
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses ChildWin;

procedure TMainForm.CloseButtonClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.CreateNewForm(AControl: TWinControl; AName: String = '');
var
  F: TSDIChild;
begin
  SendMessage(AControl.Handle, WM_SETREDRAW, 0, 0);
  Inc(Count);
  F := TSDIChild.Create(Self);
  F.ScaleForPPI(CurrentPPI);
  if AName = '' then
  begin
    F.Caption := 'NoName ' + Count.ToString;
    F.Memo1.Text := F.Caption;
  end
  else
  begin
    F.Caption := AName;
    if FileExists(AName) then F.Memo1.Lines.LoadFromFile(AName);
  end;
  F.Parent := AControl;
  F.Show;
  SendMessage(AControl.Handle, WM_SETREDRAW, 1, 0);
  RedrawWindow(AControl.Handle, nil, 0,
   RDW_ERASE or RDW_INVALIDATE or RDW_FRAME or RDW_ALLCHILDREN or RDW_UPDATENOW);
end;


procedure TMainForm.ActionMDIArrangeExecute(Sender: TObject);
begin
  if (FormStyle = fsMDIForm) and (ClientHandle <> 0) then
    SendMessage(ClientHandle, WM_MDIICONARRANGE, 0, 0);
end;

procedure TMainForm.FileNew1Execute(Sender: TObject);
begin
  CreateNewForm(ClientPanel);
end;

procedure TMainForm.FileOpen1Execute(Sender: TObject);
begin
  TStyleManager.SystemHooks := [];
  if OpenDialog.Execute then
    CreateNewForm(ClientPanel, OpenDialog.FileName);
  TStyleManager.SystemHooks := [shDialogs, shMenus, shToolTips];
end;

procedure TMainForm.FileSave1Execute(Sender: TObject);
begin
  //
end;

procedure TMainForm.MaxButtonClick(Sender: TObject);
begin
  if scStyledForm1.IsDWMClientMaximized then
    scStyledForm1.DWMClientRestore
  else
    scStyledForm1.DWMClientMaximize;
end;

procedure TMainForm.MinButtonClick(Sender: TObject);
begin
  Application.Minimize;
end;

procedure TMainForm.PopupMenu1Popup(Sender: TObject);
begin
  scFormTabsBar1.CreateTabsMenuItems(Windows1, nil, 20);
  scStyledForm1.CreateStyleMenu(Styles1);
end;

procedure TMainForm.PopupMenu2Popup(Sender: TObject);
begin
  scFormTabsBar1.CreateTabsMenuItems(PopupMenu2.Items, TabsMenuButton);
end;

procedure TMainForm.scFormTabsBar1AcceptForm(AForm: TForm;
  var AAccept: Boolean);
begin
  AAccept := AForm is TSDIChild;
end;

procedure TMainForm.scFormTabsBar1Changed(Sender: TObject);
begin
  TabsMenuButton.Enabled := not scFormTabsBar1.IsEmpty;
  Windows1.Enabled := not scFormTabsBar1.IsEmpty;
end;

procedure TMainForm.scFormTabsBar1FormDragging(Sender: TObject);
begin
  if scStyledForm1.IsDWMClientMaximized and scStyledForm1.IsDWMClientDragging then
  begin
    scStyledForm1.DWMClientDrag;
    if not scStyledForm1.IsDWMClientMaximized then
    begin
      MaxButton.GlyphOptions.Kind := scgpbgkMaximize;
      scGPSizeBox1.Visible := True;
    end;
  end;
end;

procedure TMainForm.scFormTabsBar1FormDraggingAreaDblClick(Sender: TObject);
begin
  MaxButtonClick(Self);
end;

procedure TMainForm.scFormTabsBar1StartFormDragging(Sender: TObject);
begin
  if scStyledForm1.IsDWMClientMaximized then
     scStyledForm1.DWMClientStartDrag;
end;

procedure TMainForm.scFormTabsBar1StopFormDragging(Sender: TObject);
begin
  scStyledForm1.DWMClientEndDrag;
end;

procedure TMainForm.scGPPanel4MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) and not (ssDouble in Shift) and scStyledForm1.IsDWMClientMaximized then
   scStyledForm1.DWMClientStartDrag;
end;

procedure TMainForm.scGPPanel4MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if scStyledForm1.IsDWMClientMaximized and scStyledForm1.IsDWMClientDragging then
  begin
    scStyledForm1.DWMClientDrag;
    if not scStyledForm1.IsDWMClientMaximized then
    begin
      MaxButton.GlyphOptions.Kind := scgpbgkMaximize;
      scGPSizeBox1.Visible := True;
    end;
  end;
end;

procedure TMainForm.scGPPanel4MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  scStyledForm1.DWMClientEndDrag;
end;

procedure TMainForm.scStyledForm1ChangeActive(Sender: TObject);
begin
  if Active then
  begin
    CloseButton.GlyphOptions.NormalColorAlpha := 255;
    MinButton.GlyphOptions.NormalColorAlpha := 190;
    MaxButton.GlyphOptions.NormalColorAlpha := 190;
  end
  else
  begin
    CloseButton.GlyphOptions.NormalColorAlpha := 150;
    MinButton.GlyphOptions.NormalColorAlpha := 120;
    MaxButton.GlyphOptions.NormalColorAlpha := 120;
  end;
end;

procedure TMainForm.scStyledForm1DWMClientMaximize(Sender: TObject);
begin
  MaxButton.GlyphOptions.Kind := scgpbgkRestore;
  scGPSizeBox1.Visible := False;
  BorderPanel.Sizeable := False;
end;

procedure TMainForm.scStyledForm1DWMClientRestore(Sender: TObject);
begin
  MaxButton.GlyphOptions.Kind := scgpbgkMaximize;
  scGPSizeBox1.Visible := True;
  BorderPanel.Sizeable := True;
end;

procedure TMainForm.FileExit1Execute(Sender: TObject);
begin
  Close;
end;

end.
